<template>
    <v-container color="#EEEEEE">
        <v-toolbar color="#263238" dark style="margin-top: -30px">
            <v-spacer></v-spacer>
            <v-toolbar-title><span style="color: #FBC02D">BEE</span> PANEL</v-toolbar-title>
            <v-spacer></v-spacer>
            <v-btn icon>
                <v-icon>mdi-magnify</v-icon>
            </v-btn>
        </v-toolbar>
        <v-row align="center">
            <v-col cols="1">
                <a @click="$router.go(-1)">
                    <img width="70px" src="~@/assets/icons/regresar.svg" alt srcset />
                </a>
            </v-col>
            <v-col cols="1">
                <h5 class="tit">Regresar</h5>
            </v-col>
        </v-row>

        <v-tabs v-model="initial">
            <v-tab v-for="tab in getTabs" :key="tab.name">{{ tab.name }}</v-tab>
        </v-tabs>

        <v-tabs-items v-model="initial">
            <v-tab-item v-for="tab in getTabs" :key="tab.name">
                <v-container style="height: 1000px; max-height: max-content">
                    <v-row dense v-show="tab.ListReview.length > 0">
                        <v-container>
                            <v-card max-width="800" class="mx-auto">
                                <v-list two-line>
                                    <v-list-item-group v-model="selected" multiple active-class="pink--text">
                                        <template v-for="(item, index) in tab.ListReview">
                                            <v-list-item :key="item.name">
                                                <template v-slot:default="{ active }">
                                                    <v-list-item-content>
                                                        <v-list-item-title v-text="item.name"></v-list-item-title>
                                                        <v-list-item-title>{{
                                                            getProductOfReviewName(item.id)
                                                        }}</v-list-item-title>
                                                        <v-list-item-subtitle
                                                            v-text="item.content"
                                                        ></v-list-item-subtitle>
                                                    </v-list-item-content>

                                                    <v-list-item-action>
                                                        <v-list-item-action-text
                                                            v-text="formatDate(item.createdAt.toDate())"
                                                        ></v-list-item-action-text>

                                                        <v-checkbox
                                                            @change="
                                                                updateReview(
                                                                    $event,
                                                                    item.approved,
                                                                    item.id,
                                                                    item.dishId
                                                                )
                                                            "
                                                            v-model="item.approved"
                                                            >Aceptar</v-checkbox
                                                        >
                                                        <v-btn icon color="indigo">
                                                            <v-icon v-if="!active" color="grey lighten-1"
                                                                >mdi-star</v-icon
                                                            >
                                                            <v-icon v-else color="yellow">mdi-star</v-icon>
                                                        </v-btn>
                                                    </v-list-item-action>
                                                </template>
                                            </v-list-item>
                                            <v-divider v-if="index + 1 < item.length" :key="index"></v-divider>
                                        </template>
                                    </v-list-item-group>
                                </v-list>
                            </v-card>
                        </v-container>
                    </v-row>
                </v-container>
            </v-tab-item>
        </v-tabs-items>
    </v-container>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator';
import { db } from '@/config/firebase';
import { Reviews } from '@/model/menu/Reviews';
import { serializeDish, serializeReview } from '@/config/serializables';
import { MENUS, REVIEWS } from '@/config/collectionsName';
import { Dish } from '@/model/menu/Dish';

@Component
export default class Review extends Vue {
    tabs: { name: string; ListReview: Reviews[] }[] = [];
    reviews: Reviews[] = [];
    products: Dish[] = [];
    selected = [1];
    initial = '';
    list: string[] = [];

    async created() {
        this.tabInit();
        await this.$bind('reviews', db.collectionGroup('reviews').where('menuId', '==', this.$route.params.id), {
            serialize: serializeReview
        });

        await this.$bind('products', db.collectionGroup('products').where('menuId', '==', this.$route.params.id), {
            serialize: serializeDish
        });
    }
    get getTabs() {
        this.tabInit();
        return this.tabs;
    }

    get positivesComments(): Reviews[] {
        return this.reviews.filter(review => review.positive);
    }

    get negativeComments(): Reviews[] {
        return this.reviews.filter(review => !review.positive);
    }
    get acceptedComments(): Reviews[] {
        return this.reviews.filter(review => review.approved);
    }
    tabInit() {
        this.tabs = [
            { name: 'Positivos', ListReview: this.positivesComments },
            { name: 'Negativos', ListReview: this.negativeComments },
            { name: 'Aceptados', ListReview: this.acceptedComments }
        ];
    }

    async updateReview(e: Event, approved: boolean, id: string, productId: string) {
        await db
            .collection(MENUS)
            .doc(this.$route.params.id)
            .collection('products')
            .doc(productId)
            .collection(REVIEWS)
            .doc(id)
            .update({
                approved
            });
    }

    getProductOfReviewName(reviewId: string) {
        const review = this.reviews.find(r => r.id == reviewId);
        if (review == undefined) {
            return '';
        }
        const product = this.products.find(p => p.id == review.dishId);
        if (product == undefined) {
            return '';
        }
        return product.name;
    }

    formatDate(d: Date) {
        return d.toLocaleDateString() + '  -  ' + d.toLocaleTimeString();
    }
}
</script>

<style type="text/css">
@media (max-width: 700px) {
    .tit {
        margin-left: 58px;
        position: absolute;
        font-size: 12px;
    }
}

@media screen and (max-width: 800px) {
    .tit {
        width: 100px;
        height: 100px;
        margin-left: 58px;
        position: absolute;
    }
}
</style>
